# Ansible managed
{# Set up SSL VirtualHosts #}
{#  for only selects one vhost per template call, when servername equals current_vhost (passed from task loop) #}
{% for vhost in apache_vhosts if vhost.servername == current_vhost and vhost.ssl %}
<VirtualHost {{ apache_listen_ip }}:{{ apache_listen_port_ssl }}>
  ServerName {{ vhost.servername }}
{% if vhost.serveralias is defined %}
  ServerAlias {{ vhost.serveralias }}
{% endif %}
{% if vhost.documentroot is defined %}
  DocumentRoot "{{ vhost.documentroot }}"
{% endif %}

{% if vhost.servername != apache_vhosts[0].servername %}
{% set key_servername = apache_vhosts[0].servername %}
{% else %}
{% set key_servername = vhost.servername %}
{% endif %}
{% set letsencrypt_vhost_path = '/etc/letsencrypt/live/' +  key_servername + '/' %}
{% set default_cert_file = letsencrypt_vhost_path + 'cert.pem' %}
{% set default_cert_key = letsencrypt_vhost_path + 'privkey.pem' %}
{% set default_chain_file = letsencrypt_vhost_path + 'chain.pem' %}
  {#block for setting sertificate for letsencrypt #}
  {% if vhost.ssl_type is undefined or vhost.ssl_type == 'letsencrypt' %}
  Include /etc/letsencrypt/options-ssl-apache.conf

  SSLCompression off

  SSLCertificateFile {{ vhost.certificate_file | default(default_cert_file) }}
  SSLCertificateKeyFile {{ vhost.certificate_key_file | default(default_cert_key) }}
  SSLCertificateChainFile {{vhost.certificate_chain_file | default(default_chain_file) }}
  {% endif %}

  {# block for setting sertificate for uib host #}
  {% if vhost.ssl_type | default('') == 'uib'  %}

  {# ssl config copied from letsencrypt options #}
  SSLEngine on
  # Intermediate configuration, tweak to your needs
  SSLProtocol             all -SSLv2 -SSLv3 -TLSv1 -TLSv1.1
  SSLCipherSuite          ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384
  SSLHonorCipherOrder     off

SSLOptions +StrictRequire
  SSLCompression off

  SSLCertificateFile {{ vhost.certificate_file | default('/etc/pki/tls/certs/'+ key_servername + '.pem') }}
  SSLCertificateKeyFile {{ vhost.certificate_key_file | default('/etc/pki/tls/private/' + key_servername + '.pem') }}
  SSLCertificateChainFile {{vhost.certificate_chain_file | default('/etc/pki/tls/certs/' + key_servername + '.chain.pem') }}

  {% endif %}
{% if vhost.serveradmin is defined %}
  ServerAdmin {{ vhost.serveradmin }}
{% endif %}

{% if vhost.apache24_require is defined %}
<Location />
{{ vhost.apache24_require }}
</Location>
{% endif %}

{% if vhost.documentroot is defined %}
  <Directory "{{ vhost.documentroot }}">
    AllowOverride {{ vhost.allow_override | default(apache_allow_override) }}
    Options {{ vhost.options | default(apache_options) }}
{% if apache_vhosts_version == "2.2" %}
    Order allow,deny
    Allow from all
{% endif %}
{# duplicating apache24_require section in order to match both external locations and starting from web-root #}
  {{ vhost.apache24_require | default('') }}
  </Directory>

{% endif %}

{% if apache_deny_git %}
<LocationMatch ".git/">
Require all denied
</LocationMatch>
{% endif %}

{% if vhost.extra_parameters is defined %}
  {{ vhost.extra_parameters }}
{% endif %}
</VirtualHost>

{% endfor %}

